package oopsla.bpmn.diagram.edit.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gmf.runtime.notation.View;
import oopsla.bpmn.Association;
import oopsla.bpmn.BpmnPackage;
import oopsla.bpmn.GraphicalObject;
import oopsla.bpmn.MessageFlow;
import oopsla.bpmn.SequenceFlow;

import oopsla.bpmn.diagram.providers.BpmnElementTypes;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.gef.commands.UnexecutableCommand;

import org.eclipse.gmf.runtime.emf.type.core.commands.CreateRelationshipCommand;

/**
 * @generated
 */
public class IntermediateEventItemSemanticEditPolicy extends
		BpmnBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		return getMSLWrapper(new DestroyElementCommand(req) {

			protected EObject getElementToDestroy() {
				View view = (View) getHost().getModel();
				EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
				if (annotation != null) {
					return view;
				}
				return super.getElementToDestroy();
			}

		});
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (BpmnElementTypes.SequenceFlow_4001 == req.getElementType()) {
			return req.getTarget() == null ? getCreateStartOutgoingSequenceFlow4001Command(req)
					: getCreateCompleteIncomingSequenceFlow4001Command(req);
		}
		if (BpmnElementTypes.Association_4002 == req.getElementType()) {
			return req.getTarget() == null ? getCreateStartOutgoingAssociation4002Command(req)
					: getCreateCompleteIncomingAssociation4002Command(req);
		}
		if (BpmnElementTypes.MessageFlow_4003 == req.getElementType()) {
			return req.getTarget() == null ? getCreateStartOutgoingMessageFlow4003Command(req)
					: getCreateCompleteIncomingMessageFlow4003Command(req);
		}
		return super.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getCreateStartOutgoingSequenceFlow4001Command(
			CreateRelationshipRequest req) {
		return new Command() {
		};
	}

	/**
	 * @generated
	 */
	protected Command getCreateCompleteIncomingSequenceFlow4001Command(
			CreateRelationshipRequest req) {
		if (!(req.getSource() instanceof GraphicalObject)) {
			return UnexecutableCommand.INSTANCE;
		}
		final oopsla.bpmn.Process element = (oopsla.bpmn.Process) getRelationshipContainer(
				req.getSource(), BpmnPackage.eINSTANCE.getProcess(), req
						.getElementType());
		if (element == null) {
			return UnexecutableCommand.INSTANCE;
		}
		if (req.getContainmentFeature() == null) {
			req.setContainmentFeature(BpmnPackage.eINSTANCE
					.getProcess_GraphicalElements());
		}
		return getMSLWrapper(new CreateIncomingSequenceFlow4001Command(req) {

			/**
			 * @generated
			 */
			protected EObject getElementToEdit() {
				return element;
			}
		});
	}

	/**
	 * @generated
	 */
	private static class CreateIncomingSequenceFlow4001Command extends
			CreateRelationshipCommand {

		/**
		 * @generated
		 */
		public CreateIncomingSequenceFlow4001Command(
				CreateRelationshipRequest req) {
			super(req);
		}

		/**
		 * @generated
		 */
		protected EClass getEClassToEdit() {
			return BpmnPackage.eINSTANCE.getProcess();
		};

		/**
		 * @generated
		 */
		protected void setElementToEdit(EObject element) {
			throw new UnsupportedOperationException();
		}

		/**
		 * @generated
		 */
		protected EObject doDefaultElementCreation() {
			SequenceFlow newElement = (SequenceFlow) super
					.doDefaultElementCreation();
			if (newElement != null) {
				newElement.setTarget((GraphicalObject) getTarget());
				newElement.setSource((GraphicalObject) getSource());
			}
			return newElement;
		}
	}

	/**
	 * @generated
	 */
	protected Command getCreateStartOutgoingAssociation4002Command(
			CreateRelationshipRequest req) {
		if (!BpmnBaseItemSemanticEditPolicy.LinkConstraints.Association_4002
				.canCreateLink(req, false)) {
			return UnexecutableCommand.INSTANCE;
		}
		return new Command() {
		};
	}

	/**
	 * @generated
	 */
	protected Command getCreateCompleteIncomingAssociation4002Command(
			CreateRelationshipRequest req) {
		if (!(req.getSource() instanceof GraphicalObject)) {
			return UnexecutableCommand.INSTANCE;
		}
		final oopsla.bpmn.Process element = (oopsla.bpmn.Process) getRelationshipContainer(
				req.getSource(), BpmnPackage.eINSTANCE.getProcess(), req
						.getElementType());
		if (element == null) {
			return UnexecutableCommand.INSTANCE;
		}
		if (!BpmnBaseItemSemanticEditPolicy.LinkConstraints.Association_4002
				.canCreateLink(req, false)) {
			return UnexecutableCommand.INSTANCE;
		}
		if (req.getContainmentFeature() == null) {
			req.setContainmentFeature(BpmnPackage.eINSTANCE
					.getProcess_GraphicalElements());
		}
		return getMSLWrapper(new CreateIncomingAssociation4002Command(req) {

			/**
			 * @generated
			 */
			protected EObject getElementToEdit() {
				return element;
			}
		});
	}

	/**
	 * @generated
	 */
	private static class CreateIncomingAssociation4002Command extends
			CreateRelationshipCommand {

		/**
		 * @generated
		 */
		public CreateIncomingAssociation4002Command(
				CreateRelationshipRequest req) {
			super(req);
		}

		/**
		 * @generated
		 */
		protected EClass getEClassToEdit() {
			return BpmnPackage.eINSTANCE.getProcess();
		};

		/**
		 * @generated
		 */
		protected void setElementToEdit(EObject element) {
			throw new UnsupportedOperationException();
		}

		/**
		 * @generated
		 */
		protected EObject doDefaultElementCreation() {
			Association newElement = (Association) super
					.doDefaultElementCreation();
			if (newElement != null) {
				newElement.setTarget((GraphicalObject) getTarget());
				newElement.setSource((GraphicalObject) getSource());
			}
			return newElement;
		}
	}

	/**
	 * @generated
	 */
	protected Command getCreateStartOutgoingMessageFlow4003Command(
			CreateRelationshipRequest req) {
		return new Command() {
		};
	}

	/**
	 * @generated
	 */
	protected Command getCreateCompleteIncomingMessageFlow4003Command(
			CreateRelationshipRequest req) {
		if (!(req.getSource() instanceof GraphicalObject)) {
			return UnexecutableCommand.INSTANCE;
		}
		final oopsla.bpmn.Process element = (oopsla.bpmn.Process) getRelationshipContainer(
				req.getSource(), BpmnPackage.eINSTANCE.getProcess(), req
						.getElementType());
		if (element == null) {
			return UnexecutableCommand.INSTANCE;
		}
		if (req.getContainmentFeature() == null) {
			req.setContainmentFeature(BpmnPackage.eINSTANCE
					.getProcess_GraphicalElements());
		}
		return getMSLWrapper(new CreateIncomingMessageFlow4003Command(req) {

			/**
			 * @generated
			 */
			protected EObject getElementToEdit() {
				return element;
			}
		});
	}

	/**
	 * @generated
	 */
	private static class CreateIncomingMessageFlow4003Command extends
			CreateRelationshipCommand {

		/**
		 * @generated
		 */
		public CreateIncomingMessageFlow4003Command(
				CreateRelationshipRequest req) {
			super(req);
		}

		/**
		 * @generated
		 */
		protected EClass getEClassToEdit() {
			return BpmnPackage.eINSTANCE.getProcess();
		};

		/**
		 * @generated
		 */
		protected void setElementToEdit(EObject element) {
			throw new UnsupportedOperationException();
		}

		/**
		 * @generated
		 */
		protected EObject doDefaultElementCreation() {
			MessageFlow newElement = (MessageFlow) super
					.doDefaultElementCreation();
			if (newElement != null) {
				newElement.setTarget((GraphicalObject) getTarget());
				newElement.setSource((GraphicalObject) getSource());
			}
			return newElement;
		}
	}
}
