package oopsla.bpmn.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.diagram.core.providers.AbstractViewProvider;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import oopsla.bpmn.diagram.edit.parts.AssociationEditPart;
import oopsla.bpmn.diagram.edit.parts.DataExclusiveGatewayEditPart;
import oopsla.bpmn.diagram.edit.parts.DataObjectEditPart;
import oopsla.bpmn.diagram.edit.parts.DataObjectNameEditPart;
import oopsla.bpmn.diagram.edit.parts.DiagramEditPart;
import oopsla.bpmn.diagram.edit.parts.EndEventEditPart;
import oopsla.bpmn.diagram.edit.parts.IntermediateEventEditPart;
import oopsla.bpmn.diagram.edit.parts.MessageFlowEditPart;
import oopsla.bpmn.diagram.edit.parts.ParallelGatewayEditPart;
import oopsla.bpmn.diagram.edit.parts.PoolEditPart;
import oopsla.bpmn.diagram.edit.parts.ProcessEditPart;
import oopsla.bpmn.diagram.edit.parts.SequenceFlowEditPart;
import oopsla.bpmn.diagram.edit.parts.StartEventEditPart;
import oopsla.bpmn.diagram.edit.parts.TaskEditPart;
import oopsla.bpmn.diagram.edit.parts.TaskNameEditPart;

import oopsla.bpmn.diagram.part.BpmnVisualIDRegistry;

import oopsla.bpmn.diagram.view.factories.AssociationViewFactory;
import oopsla.bpmn.diagram.view.factories.DataExclusiveGatewayViewFactory;
import oopsla.bpmn.diagram.view.factories.DataObjectNameViewFactory;
import oopsla.bpmn.diagram.view.factories.DataObjectViewFactory;
import oopsla.bpmn.diagram.view.factories.DiagramViewFactory;
import oopsla.bpmn.diagram.view.factories.EndEventViewFactory;
import oopsla.bpmn.diagram.view.factories.IntermediateEventViewFactory;
import oopsla.bpmn.diagram.view.factories.MessageFlowViewFactory;
import oopsla.bpmn.diagram.view.factories.ParallelGatewayViewFactory;
import oopsla.bpmn.diagram.view.factories.PoolViewFactory;
import oopsla.bpmn.diagram.view.factories.ProcessViewFactory;
import oopsla.bpmn.diagram.view.factories.SequenceFlowViewFactory;
import oopsla.bpmn.diagram.view.factories.StartEventViewFactory;
import oopsla.bpmn.diagram.view.factories.TaskNameViewFactory;
import oopsla.bpmn.diagram.view.factories.TaskViewFactory;

/**
 * @generated
 */
public class BpmnViewProvider extends AbstractViewProvider {

	/**
	 * @generated
	 */
	protected Class getDiagramViewClass(IAdaptable semanticAdapter,
			String diagramKind) {
		EObject semanticElement = getSemanticElement(semanticAdapter);
		if (DiagramEditPart.MODEL_ID.equals(diagramKind)
				&& BpmnVisualIDRegistry.getDiagramVisualID(semanticElement) != -1) {
			return DiagramViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		if (containerView == null) {
			return null;
		}
		IElementType elementType = getSemanticElementType(semanticAdapter);
		if (elementType != null
				&& !BpmnElementTypes.isKnownElementType(elementType)) {
			return null;
		}
		EClass semanticType = getSemanticEClass(semanticAdapter);
		EObject semanticElement = getSemanticElement(semanticAdapter);
		int nodeVID = BpmnVisualIDRegistry.getNodeVisualID(containerView,
				semanticElement, semanticType, semanticHint);
		switch (nodeVID) {
		case PoolEditPart.VISUAL_ID:
			return PoolViewFactory.class;
		case ProcessEditPart.VISUAL_ID:
			return ProcessViewFactory.class;
		case TaskEditPart.VISUAL_ID:
			return TaskViewFactory.class;
		case TaskNameEditPart.VISUAL_ID:
			return TaskNameViewFactory.class;
		case StartEventEditPart.VISUAL_ID:
			return StartEventViewFactory.class;
		case EndEventEditPart.VISUAL_ID:
			return EndEventViewFactory.class;
		case ParallelGatewayEditPart.VISUAL_ID:
			return ParallelGatewayViewFactory.class;
		case DataExclusiveGatewayEditPart.VISUAL_ID:
			return DataExclusiveGatewayViewFactory.class;
		case DataObjectEditPart.VISUAL_ID:
			return DataObjectViewFactory.class;
		case DataObjectNameEditPart.VISUAL_ID:
			return DataObjectNameViewFactory.class;
		case IntermediateEventEditPart.VISUAL_ID:
			return IntermediateEventViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		IElementType elementType = getSemanticElementType(semanticAdapter);
		if (elementType != null
				&& !BpmnElementTypes.isKnownElementType(elementType)) {
			return null;
		}
		EClass semanticType = getSemanticEClass(semanticAdapter);
		if (semanticType == null) {
			return null;
		}
		EObject semanticElement = getSemanticElement(semanticAdapter);
		int linkVID = BpmnVisualIDRegistry.getLinkWithClassVisualID(
				semanticElement, semanticType);
		switch (linkVID) {
		case SequenceFlowEditPart.VISUAL_ID:
			return SequenceFlowViewFactory.class;
		case AssociationEditPart.VISUAL_ID:
			return AssociationViewFactory.class;
		case MessageFlowEditPart.VISUAL_ID:
			return MessageFlowViewFactory.class;
		}
		return getUnrecognizedConnectorViewClass(semanticAdapter,
				containerView, semanticHint);
	}

	/**
	 * @generated
	 */
	private IElementType getSemanticElementType(IAdaptable semanticAdapter) {
		if (semanticAdapter == null) {
			return null;
		}
		return (IElementType) semanticAdapter.getAdapter(IElementType.class);
	}

	/**
	 * @generated
	 */
	private Class getUnrecognizedConnectorViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		// Handle unrecognized child node classes here
		return null;
	}

}
